<?php
/**
* @name			brightcove.php
* @description	This plugin embeds a brightcove video. Embed a video the following way: {brightcrove|width|height|playerID|playerKey|videoPlayer}.
* @version		2.5
* @support		Support is commercial. Please check http://www.itoctopus.com/fees for the applicable rates.
* @supports		Joomla 2.5
* @copyright	Copyright (C) 2014 itoctopus
* @license		GPL
* @legal		By using this plugin, you agree that itoctopus cannot be held responsible for any damage this plugin may cause, whether directly or indirectly.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class  plgSystemBrightcove extends JPlugin
{

	/**
	 * Constructor
	 */
	function plgSystemBrightcove(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onAfterRender()
	{
		//get out if it's in admin
		$app = &JFactory::getApplication();
		if($app->isAdmin() || JDEBUG) {
			return;
		}

		$body = JResponse::getBody();


		if (stripos($body, "{brightcove") !== FALSE){
			$arrBrightCove = explode("{brightcove|", $body);
			$arrResult = array();
			for ($i = 0; $i < count($arrBrightCove); $i++){
				$width 			= "";
				$height 		= "";
				$playerID 		= "";
				$playerKey 		= "";
				$videoPlayer 	= "";
				
				
				$arrBrightCoveSettingsRaw = explode("}", $arrBrightCove[$i]);
				//now this part can contain a CSS class as well
				$arrBrightCoveSettings = explode('|', $arrBrightCoveSettingsRaw[0]);
				$to_replace = '{brightcove|'.$arrBrightCoveSettingsRaw[0].'}';
				if (count($arrBrightCoveSettings) == 5){
					$width 			= $arrBrightCoveSettings[0];
					$height 		= $arrBrightCoveSettings[1];
					$playerID 		= $arrBrightCoveSettings[2];
					$playerKey 		= $arrBrightCoveSettings[3];
					$videoPlayer 	= $arrBrightCoveSettings[4];
				}
				$replace = '<script language="JavaScript" src="http://admin.brightcove.com/js/BrightcoveExperiences.js" type="text/javascript"></script>
				<object id="myExperience'.$videoPlayer.'" class="BrightcoveExperience">
				<param name="bgcolor" value="#FFFFFF" />
				<param name="width" value="'.$width.'" />
				<param name="height" value="'.$height.'" />
				<param name="playerID" value="'.$playerID.'" />
				<param name="playerKey" value="'.$playerKey.'" />
				<param name="isVid" value="true" />
				<param name="isUI" value="true" />
				<param name="dynamicStreaming" value="true" />
				<param name="@videoPlayer" value="'.$videoPlayer.'" />
				</object>
				<script type="text/javascript">// <![CDATA[
				brightcove.createExperiences();
				// ]]></script>';
				$body = str_replace($to_replace, $replace, $body);
			}
			JResponse::setBody($body);
		}
		
	}
}